//+--------------------------------------------------------------------------+
//|                                                3 MA Cross with alert.mq4 |
//|                                                                   mladen |
//+--------------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 DodgerBlue
#property indicator_color2 Red
#property indicator_color3 Gold
#property indicator_color4 Gold
#property indicator_color5 Lime
#property indicator_color6 YellowGreen
#property indicator_color7 CadetBlue
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    FasterMA         = 5;
extern int    FasterShift      = 0;
extern int    FasterMode       = 1;
extern int    MediumMA         = 20;
extern int    MediumShift      = 0;
extern int    MediumMode       = 1;
extern int    SlowerMA         = 34;
extern int    SlowerShift      = 0;
extern int    SlowerMode       = 1;
extern bool   showMAs          = true;
extern bool   crossesOnCurrent = true;
extern bool   alertsOn         = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsNotify     = false;
extern bool   alertsEmail      = false;
extern bool   ArrowOnFirstBar  = true;


//
//
//
//
//

double CrossUp[];
double CrossDn[];
double CrossWUp[];
double CrossWDn[];
double ma1[];
double ma2[];
double ma3[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,CrossUp);  SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 233);
   SetIndexBuffer(1,CrossDn);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 234);
   SetIndexBuffer(2,CrossWUp); SetIndexStyle(2, DRAW_ARROW); SetIndexArrow(2, 233);
   SetIndexBuffer(3,CrossWDn); SetIndexStyle(3, DRAW_ARROW); SetIndexArrow(3, 234);
   SetIndexBuffer(4,ma1); 
   SetIndexBuffer(5,ma2); 
   SetIndexBuffer(6,ma3); 
   if (showMAs)
   {
      SetIndexStyle(4,DRAW_LINE);
      SetIndexStyle(5,DRAW_LINE);
      SetIndexStyle(6,DRAW_LINE);
   }      
   else
   {
      SetIndexStyle(4,DRAW_NONE);
      SetIndexStyle(5,DRAW_NONE);
      SetIndexStyle(6,DRAW_NONE);
   } 
   
   //
   //
   //
   //
   //
   
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
   SetIndexShift(4,FasterShift*timeFrame/Period());
   SetIndexShift(5,MediumShift*timeFrame/Period());
   SetIndexShift(6,SlowerShift*timeFrame/Period());
   
   IndicatorShortName(timeFrameToString(timeFrame)+" 3 ma cross ");     
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{ 
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (FasterShift < 0) limit = MathMax(limit,-FasterShift);
           if (MediumShift < 0) limit = MathMax(limit,-MediumShift);
           if (SlowerShift < 0) limit = MathMax(limit,-SlowerShift);
           if (returnBars) { CrossUp[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               int shift = -1; if (ArrowOnFirstBar) shift=1;
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);   
                  int x = iBarShift(NULL,timeFrame,Time[i+shift]);            
                     ma1[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FasterMA,0,FasterMode,MediumMA,0,MediumMode,SlowerMA,0,SlowerMode,showMAs,crossesOnCurrent,alertsOn,alertsMessage,alertsSound,alertsNotify,alertsEmail,4,y);
                     ma2[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FasterMA,0,FasterMode,MediumMA,0,MediumMode,SlowerMA,0,SlowerMode,showMAs,crossesOnCurrent,alertsOn,alertsMessage,alertsSound,alertsNotify,alertsEmail,5,y);
                     ma3[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FasterMA,0,FasterMode,MediumMA,0,MediumMode,SlowerMA,0,SlowerMode,showMAs,crossesOnCurrent,alertsOn,alertsMessage,alertsSound,alertsNotify,alertsEmail,6,y);
                  if (x!=y)
                  {
                     CrossUp[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FasterMA,0,FasterMode,MediumMA,0,MediumMode,SlowerMA,0,SlowerMode,showMAs,crossesOnCurrent,alertsOn,alertsMessage,alertsSound,alertsNotify,alertsEmail,0,y);
                     CrossDn[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FasterMA,0,FasterMode,MediumMA,0,MediumMode,SlowerMA,0,SlowerMode,showMAs,crossesOnCurrent,alertsOn,alertsMessage,alertsSound,alertsNotify,alertsEmail,1,y);
                     CrossWUp[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FasterMA,0,FasterMode,MediumMA,0,MediumMode,SlowerMA,0,SlowerMode,showMAs,crossesOnCurrent,alertsOn,alertsMessage,alertsSound,alertsNotify,alertsEmail,2,y);
                     CrossWDn[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FasterMA,0,FasterMode,MediumMA,0,MediumMode,SlowerMA,0,SlowerMode,showMAs,crossesOnCurrent,alertsOn,alertsMessage,alertsSound,alertsNotify,alertsEmail,3,y);
                  }
                  else
                  {
                     CrossUp[i]  = EMPTY_VALUE;
                     CrossDn[i]  = EMPTY_VALUE;
                     CrossWUp[i] = EMPTY_VALUE;
                     CrossWDn[i] = EMPTY_VALUE;
                  }                      
               }
               return(0);
     }
     
     //
     //
     //
     //
     //
     
     for(i = limit; i >=0; i--)
     {    
        ma1[i] = iMA(NULL, 0, FasterMA, FasterShift, FasterMode, PRICE_CLOSE, i);
        ma2[i] = iMA(NULL, 0, MediumMA, MediumShift, MediumMode, PRICE_CLOSE, i);
        ma3[i] = iMA(NULL, 0, SlowerMA, SlowerShift, SlowerMode, PRICE_CLOSE, i);

         if (crossesOnCurrent==false && i==0) continue;
         
      //
      //
      //
      //
      //
         
         double fasterMAnow      = ma1[i];
         double fasterMAprevious = ma1[i+1];
         double mediumMAnow      = ma2[i];
         double mediumMAprevious = ma2[i+1];
         double slowerMAnow      = ma3[i];
         double slowerMAprevious = ma3[i+1];
      
      //
      //
      //
      //
      //
      
      int    crossID=0;
      double curr;
      double prev;
      double point;
      while (true)
         {
            if (fasterMAnow > 0 && mediumMAnow > 0)
               {
                  curr  =  fasterMAnow      - mediumMAnow;
                  prev  =  fasterMAprevious - mediumMAprevious;
                  point = (fasterMAnow      + fasterMAprevious)/2;
                     if (curr*prev<=0) { crossID=1; break; }
               }                     
            if (fasterMAnow > 0 && slowerMAnow > 0)
               {
                  curr  =  fasterMAnow      - slowerMAnow;
                  prev  =  fasterMAprevious - slowerMAprevious;
                  point = (fasterMAnow      + fasterMAprevious)/2;
                     if (curr*prev<=0) { crossID=2; break; }
               }
            if (mediumMAnow > 0 && slowerMAnow > 0)
               {
                  curr  =  mediumMAnow      - slowerMAnow;
                  prev  =  mediumMAprevious - slowerMAprevious;
                  point = (mediumMAnow      + mediumMAprevious)/2;
                        if (curr*prev<=0) { crossID=3; break; }
               }                        
               break;
         }
      
         //
         //
         //
         //
         //
         
         CrossUp[i]  = EMPTY_VALUE;
         CrossDn[i]  = EMPTY_VALUE;
         CrossWUp[i] = EMPTY_VALUE;
         CrossWDn[i] = EMPTY_VALUE;
         if (crossID>0)
         {
            if (alertsOn)
            if ((i==0 && crossesOnCurrent==true) || (i==1 && crossesOnCurrent==false))
            {
               switch (crossID)
               {
                  case 1: 
                        if(curr>0) doAlert("Fast MA crossed Medium MA UP");
                        else       doAlert("Fast MA crossed Medium MA DOWN"); 
                        break;
                  case 2: 
                        if(curr>0) doAlert("Fast MA crossed Slow MA UP");
                        else       doAlert("Fast MA crossed Slow MA DOWN"); 
                        break;
                  case 3: 
                        if(curr>0) doAlert("Medium MA crossed Slow MA UP");
                        else       doAlert("Medium MA crossed Slow MA DOWN"); 
                        break;
               }
            }               
            
            //
            //
            //
            //
            //
            
            if (i==0)
            {
               if (curr>0)
                     CrossWUp[i] = point - iATR(NULL,0,20,i)*0.5;
               else  CrossWDn[i] = point + iATR(NULL,0,20,i)*0.5;
            }               
            else
            {               
               if (curr>0)
                     CrossUp[i] = point - iATR(NULL,0,20,i)*0.5;
               else  CrossDn[i] = point + iATR(NULL,0,20,i)*0.5;
            }               
         }               
   }   
   return(0);
 }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
 
void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," 3 MA line crossing ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"3 MA line crossing"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

